
void definePlatforms();

extern SDL_Rect PlatformSrcRect[5];
extern bool playerOnPlatform;

typedef struct {
	int x, y;		//
	int w, h;		//
	int direction;		// 0 = horizontal / 1 = vertical
} PlatformTypeDefinition;
extern PlatformTypeDefinition PlatformType[5];

typedef struct {
	int x, y;		//
	int type;
	int direction;		// 0 = Left, 1 = Right / 0 = up, 1 = down
	int pathlength;		// how many pixels is the platform supposed to move
    int movepos;  // how many pixels has the platform moved so far
    bool inUse;  // how many pixels has the platform moved so far
} PlatformImplementation;
extern PlatformImplementation Platform[5];
