
typedef struct {
	Sint16 x, y;
	Sint16 xold, yold;
	Uint16 w, h;
	Uint16 jumpcounter;
	bool onground;
	Sint16 accelleration;
	Uint16 direction;
	Uint16 Bonus;
    Uint16 CoinsThisStage;
} PlayableCharacter;

extern PlayableCharacter Player;

extern SDL_Rect BulletSrcRect[4];
extern SDL_Rect BulletExplosionSrcRect[2];
extern int BulletPosX, BulletPosY;
extern bool BulletDirH;
extern bool BulletDirV;

extern SDL_Rect PlayerRightSrcRect[4];
extern SDL_Rect PlayerLeftSrcRect[4];
extern SDL_Rect PlayerJumpRightSrcRect;
extern SDL_Rect PlayerJumpLeftSrcRect;
extern SDL_Rect PlayerTurnRightSrcRect;
extern SDL_Rect PlayerTurnLeftSrcRect;
extern SDL_Rect PlayerDeadSrcRect;
extern SDL_Rect PlayerPunkRightSrcRect[4];
extern SDL_Rect PlayerPunkLeftSrcRect[4];
extern SDL_Rect PlayerPunkJumpRightSrcRect;
extern SDL_Rect PlayerPunkJumpLeftSrcRect;
extern SDL_Rect PlayerPunkTurnRightSrcRect;
extern SDL_Rect PlayerPunkTurnLeftSrcRect;
extern SDL_Rect PlayerMorphSrcRect[2];


extern int WalkAnimationCounter;
extern int WalkAnimationNumber;
extern bool PlayerDied;

void definePlayer();
