#include "_variables.h"

void draw_infoscreen(int x_off, int y_off)
{
// draw what's behind the info screen
    drawBackground(StageBackgroundColour, 0, 0);
    drawTiles();
    drawPlatforms();
    drawCoin();
    //drawPlayer();
    drawEnemy();
    drawBonus();
    //drawStats(0,0);
// draw what's behind the info screen

  drawBackground(2, x_off, y_off);

  int i;
  Print (16+x_off,16+y_off,0, "STAGE");
  Print (112+x_off,8+y_off,0, "MAX");
  Print (96+x_off,16+y_off,0, "COINS");

  // draw a little coin next to the number
  SDL_Rect TempCoinRect;
  TempCoinRect.x = (96+x_off)*ScaleValue;
  TempCoinRect.y = (8+y_off)*ScaleValue;
  TempCoinRect.w = (8)*ScaleValue;
  TempCoinRect.h = (8)*ScaleValue;
  SDL_BlitSurface(TilesSurface,&TileSrcRect[45],DisplaySurface,&TempCoinRect);


  // Print (176,8,0, "BEST");
  // Print (176,16,0, "TIME");

  if(InfoScreenPage==0)
  {
    Print (40+x_off,32+y_off,0, "01");
    Print (40+x_off,41+y_off,0, "02");
    Print (40+x_off,50+y_off,0, "03");
    Print (40+x_off,59+y_off,0, "04");
    Print (40+x_off,68+y_off,0, "05");
    Print (40+x_off,77+y_off,0, "06");
    Print (40+x_off,86+y_off,0, "07");
    Print (40+x_off,95+y_off,0, "08");
    Print (40+x_off,104+y_off,0, "09");
    Print (40+x_off,113+y_off,0, "10");
    Print (40+x_off,122+y_off,0, "11");
    Print (40+x_off,131+y_off,0, "12");
    Print (40+x_off,140+y_off,0, "13");
    Print (40+x_off,149+y_off,0, "14");
    Print (40+x_off,158+y_off,0, "15");
    Print (40+x_off,167+y_off,0, "16");
    Print (40+x_off,176+y_off,0, "17");
    Print (40+x_off,185+y_off,0, "18");
    Print (40+x_off,194+y_off,0, "19");
    Print (40+x_off,203+y_off,0, "20");

    for(i=0; i<20; i++)
    {
      if(!StageInfo[i+1].solved)
      {
        Print (64+x_off,32+(i*9)+y_off,1, "stage not completed yet...");
      }
      if(StageInfo[i+1].solved)
      {
        if(StageInfo[i+1].maxCoins < 1000 && StageInfo[i+1].maxCoins >= 100) {PrintInt (88+x_off,32+(i*9)+y_off,0, StageInfo[i+1].maxCoins);}
        if(StageInfo[i+1].maxCoins < 100 && StageInfo[i+1].maxCoins >= 10) {PrintInt (96+x_off,32+(i*9)+y_off,0, StageInfo[i+1].maxCoins);}
        if(StageInfo[i+1].maxCoins < 10) {PrintInt (104+x_off,32+(i*9)+y_off,0, StageInfo[i+1].maxCoins);}
        Print (112+x_off,32+(i*9)+y_off,0, ";");
        PrintInt (120+x_off,32+(i*9)+y_off,0, StageInfo[i+1].totalCoins);
        if(StageInfo[i+1].maxCoins == StageInfo[i+1].totalCoins){Print (160+x_off,32+(i*9)+y_off,2, "Perfect!");}
        if(StageInfo[i+1].maxCoins < StageInfo[i+1].totalCoins){Print (160+x_off,32+(i*9)+y_off,1, "find all coins");}
      }
    }
    Print (184+x_off,224+y_off,0, "Stages 21-32 >>>");
  }

  if(InfoScreenPage==1)
  {
    Print (40+x_off,32+y_off,0, "21");
    Print (40+x_off,41+y_off,0, "22");
    Print (40+x_off,50+y_off,0, "23");
    Print (40+x_off,59+y_off,0, "24");
    Print (40+x_off,68+y_off,0, "25");
    Print (40+x_off,77+y_off,0, "26");
    Print (40+x_off,86+y_off,0, "27");
    Print (40+x_off,95+y_off,0, "28");
    Print (40+x_off,104+y_off,0, "29");
    Print (40+x_off,113+y_off,0, "30");
    Print (40+x_off,122+y_off,0, "31");
    Print (40+x_off,131+y_off,0, "32");

    for(i=20; i<32; i++)
    {
      if(!StageInfo[i+1].solved)
      {
        Print (64+x_off,32+((i-20)*9)+y_off,1, "stage not completed yet...");
      }
      if(StageInfo[i+1].solved)
      {
        if(StageInfo[i+1].maxCoins < 1000 && StageInfo[i+1].maxCoins >= 100) {PrintInt (88+x_off,32+((i-20)*9)+y_off,0, StageInfo[i+1].maxCoins);}
        if(StageInfo[i+1].maxCoins < 100 && StageInfo[i+1].maxCoins >= 10) {PrintInt (96+x_off,32+((i-20)*9)+y_off,0, StageInfo[i+1].maxCoins);}
        if(StageInfo[i+1].maxCoins < 10) {PrintInt (104+x_off,32+((i-20)*9)+y_off,0, StageInfo[i+1].maxCoins);}
        Print (112+x_off,32+((i-20)*9)+y_off,0, ";");
        PrintInt (120+x_off,32+((i-20)*9)+y_off,0, StageInfo[i+1].totalCoins);
        if(StageInfo[i+1].maxCoins == StageInfo[i+1].totalCoins){Print (160+x_off,32+((i-20)*9)+y_off,2, "Perfect!");}
        if(StageInfo[i+1].maxCoins < StageInfo[i+1].totalCoins){Print (160+x_off,32+((i-20)*9)+y_off,1, "find all coins");}
      }
    }
    Print (16+x_off,224+y_off,0, "<<< Stages 1-20");
  }

/*
  // FPS
  Uint32 FPS_Counter;
  int TempFPS = (int) (SDL_GetTicks()-FPS_Counter);
  if(TempFPS < 1){TempFPS = 1;}
  Print(4+x_off,SCREENHEIGHT-20+y_off,0, "FPS:");
  PrintInt(60+x_off,SCREENHEIGHT-20+y_off,0, (int) (1000/TempFPS));
  FPS_Counter = SDL_GetTicks();
  // FPS
*/
  SDL_UpdateRect(DisplaySurface,0,0,0,0);
}
