#include "_variables.h"

bool StompAttack;
bool PlayerClingsRight;
bool PlayerClingsLeft;
bool FinnishedGame;
int ReachedSublevelFromStage;
int SubLevelCounter;
void GoToGameEnding();

void gameLoop()
{
  ReStartPosition = 0;
  loadStage();
  PlayerDied = false;
  timecounter = SDL_GetTicks();	// reset counter
  AnimationCounter = 0;			// reset counter
  Player.onground = 0;
  EnemyAnimationCounter = 0;
  StompAttack = false;
  PlayerClingsRight = false;
  PlayerClingsLeft = false;
  BulletPosX = -8;
  BulletPosY = -8;
  BulletExplosionCounter = 0;
  subLevelReached = 0;
  SubLevelCounter = 0;
  TurningPunk=0;
  FinnishedGame = false;

  Uint32 secondsCounter = SDL_GetTicks();

  /*********************************/
  // BEGIN NORMAL GAMELOOP
  while(Key_ESCAPE_pressed == false && intLives >= 0 && !FinnishedGame)
  {
    if(PlayerDied == true) {killedScreen(STAGE_NUMBER);}
    if(exitReached == 1)
    {
      //Mix_FreeMusic(BackgroundMusic); //free the music
      updateRecords();
      if(STAGE_NUMBER==LASTSTAGE){FinnishedGame=true;}
      STAGE_NUMBER++;
      ReStartPosition = 0;
      if(ReachedSublevelFromStage !=0)
      {
        STAGE_NUMBER=ReachedSublevelFromStage;
        ReachedSublevelFromStage=0;
        ReStartPosition = 3;
      }
      if(STAGE_NUMBER > LASTSTAGE) {STAGE_NUMBER = 1;}
      if(!FinnishedGame){loadNextStageScreen(STAGE_NUMBER);}
    }

    if(subLevelReached == 1)
    {
      updateRecords();
      ReachedSublevelFromStage = STAGE_NUMBER;
      SubLevelCounter++;
      if(SubLevelCounter>5){SubLevelCounter=1;}
      STAGE_NUMBER = 33+SubLevelCounter;
      subLevelReached=0;
      loadNextStageScreen(STAGE_NUMBER);
    }

    if(SDL_GetTicks() - secondsCounter > 1000)
    {
      secondsCounter = SDL_GetTicks(); 	// reset counter
      intTime--;
      if(intTime == 0){PlayerDied = 1;} 
    }

    if(SDL_GetTicks() - timecounter > 20)
    {
      timecounter = SDL_GetTicks(); 	// reset counter
      Animation();
      getInput();
      //if(Key_F11_pressed)  {getInput();DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_ANYFORMAT);}
      if(Key_F11_pressed)  {getInput();STAGE_NUMBER++;loadNextStageScreen(STAGE_NUMBER);}
      //if(Key_F11_pressed)  {FinnishedGame=true;}
      if(Key_F12_pressed)  {getInput();DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_SWSURFACE|SDL_FULLSCREEN);}
      if(TurningPunk==0)
      {
        if(Player.jumpcounter > 100){Player.jumpcounter=0;} // this is a hack! Should not be necessary!!!
        if(Player.jumpcounter > 10){jumpUp();}
        if(Player.jumpcounter <= 10 && Player.jumpcounter > 0){Player.jumpcounter--;}
        if(Player.jumpcounter <= 0){addGravity();}
      }
      if(Button_2_pressed and Player.Bonus > 1){if(!BulletActive){startBullet();}}
      if(Key_1_pressed){gotoinfoscreen();}
      if(TurningPunk>0){TurningPunk--;}

      movePlayer();

      checkStageEnd();
      checkDiamondCollision();
      checkLethalTile();
      checkBonusCollision();
      moveEnemies();
      moveCoin();
      movePlatforms();
      drawBackground(StageBackgroundColour, 0, 0);
      drawTiles();
      drawPlatforms();
      drawCoin();
      drawPlayer();
      drawEnemy();
      drawBonus();
      drawStats(0,0);
      if(BulletActive){moveBullet();}
      if(!BulletActive){EnemyInRadar = -1;}
      if(BulletExplosionCounter > 0){explodeBullet();}
      drawBullet();

/*
  int tiley = 8 * (int((Player.y + 22) / 8));
  int tilex = 8 * (int((Player.x + 14) / 8));
*/  
//Player.y = tiley - 20 - (8-((Player.x+14)-tilex));


  //PrintInt (0,40, 0, tiley - 20 - (8-((Player.x+14)-tilex)));
//  Print(0,48,0,"X");PrintInt (16,48, 0, 8*(int ((Player.x + 15) / 8)));
 // Print(0,48,0,"X");PrintInt (16,48, 0, Player.x);
  //PrintInt (0,56, 0, ((Player.x + 15))%8);
  //Print(0,64,0,"y");PrintInt (16,64, 0, 8*(int((Player.y+22)/8)));
//  Print(0,64,0,"y");PrintInt (16,64, 0, Player.y);
  //PrintInt (0,72, 0, Player.jumpcounter);

/*
  // FPS
  Uint32 FPS_Counter;
  int TempFPS = (int) (SDL_GetTicks()-FPS_Counter);
  if(TempFPS < 1){TempFPS = 1;}
  Print(4,SCREENHEIGHT-20,0, "FPS:");
  PrintInt(60,SCREENHEIGHT-20,0, (int) (1000/TempFPS));
  FPS_Counter = SDL_GetTicks();
  // FPS
*/

      SDL_UpdateRect(DisplaySurface,0,0,0,0);
      if(STAGE_YPos > 0){STAGE_YPos -= 2;};
      if(STAGE_YPos < 0){STAGE_YPos = 0;};
    }// end of timed loop
  } // end of while... (=end of GAMELOOP)
  //Mix_FreeMusic(BackgroundMusic); //free the music
  getInput();
  if(!FinnishedGame){GoToTitlescreenScreen();}
  if(FinnishedGame){GoToGameEnding();}
}



void GoToTitlescreenScreen()
{
  timecounter = SDL_GetTicks(); 	// reset counter
  while(SDL_GetTicks() - timecounter < 500)
  {
    drawBackground(1,0,0);
    if(intLives >= 0){Print (96,16,0,  "    you quit?   ");}
    if(intLives < 0) {Print (96,16,0,  "    GAME OVER   ");}
    SDL_UpdateRect(DisplaySurface,0,0,0,0);
  }
  STAGE_NUMBER = 0;
  loadStage();
  getInput();
}


void GoToGameEnding()
{
  exitReached = 0;
  StageMission = 0;
  FinnishedGame=false;

  if(SystemNumber == 0){iniValue = readFromINI("base/default/audio.ini", "Music", "Highscore");}
  if(SystemNumber == 1){iniValue = readFromINI("base/amiga/audio.ini", "Music", "Highscore");}
  if(SystemNumber == 2){iniValue = readFromINI("base/c64/audio.ini", "Music", "Highscore");}
  if(SystemNumber == 3){iniValue = readFromINI("base/atari/audio.ini", "Music", "Highscore");}
  if(SystemNumber == 4){iniValue = readFromINI("base/amstradcpc/audio.ini", "Music", "Highscore");}
  BackgroundMusic=Mix_LoadMUS(iniValue); //load in the music
  free(iniValue);

  if(PlayMusic){Mix_PlayMusic(BackgroundMusic,-1);} //play the music
  getInput();
  while(!Key_ENTER_pressed && !Key_ESCAPE_pressed && !Button_2_pressed && SDL_GetTicks()-timecounter < 93000)
  {
    drawBackground(1,0,0);
    Print (104,109,0, "GIANA GET UP");
    Print (64,125,0,  "THE SUN HAS FRIGHTENED");
    Print (96,141,0,  "OFF THE NIGHT!");
    SDL_UpdateRect(DisplaySurface,0,0,0,0);
    getInput();
  }
  //Mix_FreeMusic(BackgroundMusic); //free the music
  STAGE_NUMBER = 0;
  loadStage();
  getInput();
}


void loadNextStageScreen(Uint32 Stage)
{
//  Mix_FreeMusic(BackgroundMusic); //free the music
  exitReached = 0;
  StageMission = 0;
  timecounter = SDL_GetTicks(); 	// reset counter
  Uint32 timecounter2 = SDL_GetTicks(); 	// reset counter
  SDL_Rect TempCoinRect;
  TempCoinRect.x = 168*ScaleValue;
  TempCoinRect.y = 108*ScaleValue;
  TempCoinRect.w = 8*ScaleValue;
  TempCoinRect.h = 8*ScaleValue;
  getInput();
  //intTime;
  //intPoints;

  if(ReachedSublevelFromStage == 0 && ReStartPosition < 3)
  {
    while (intTime > 0 && !Key_ESCAPE_pressed && !Button_2_pressed )
    {
      getInput();
      if(SDL_GetTicks()-timecounter2 >200)
      {
        timecounter2 = SDL_GetTicks();
        playSound(2);
      }
      if(SDL_GetTicks()-timecounter >50)
      {
        timecounter = SDL_GetTicks();
        Animation();
        Animation();
        intTime--;
        intPoints +=10;
        drawBackground(1,0,0);
        SDL_BlitSurface(TilesSurface,&TileSrcRect[45],DisplaySurface,&TempCoinRect);
        Print (56,92,0,  "TIME    BONUS     SCORE");
        PrintInt (64,108,0, intTime);
        Print (104,108,0, "X");
        Print (128,108,0, "10");
        PrintInt (200,108,0, intPoints);
        SDL_UpdateRect(DisplaySurface,0,0,0,0);
      }
    }
    timecounter = SDL_GetTicks();
    intPoints = intPoints + 10*intTime;
    while(!Key_ENTER_pressed && !Key_ESCAPE_pressed && !Button_2_pressed && SDL_GetTicks()-timecounter < 1000)
    {
      getInput();
    }
  }
  getInput();
  loadStage();
  getInput();
}



void killedScreen(Uint32 Stage)
{
  PlayerDied = false;
  SDL_Rect PlayerDeadRect;
  // check for restartposition here!!!
  ReStartPosition = 0;
  if(Player.x > StageStartPositionX[Stage][1]){ReStartPosition = 1;}
  if(Player.x > StageStartPositionX[Stage][2]){ReStartPosition = 2;}
  //if(Player.x > StageStartPositionX[Stage][3]){ReStartPosition = 3;}

  PlayerDeadRect.x = (STAGE_XPos + Player.x)*ScaleValue;
  PlayerDeadRect.y = (Player.y+1)*ScaleValue;
  PlayerDeadRect.w = PlayerDeadSrcRect.w;
  PlayerDeadRect.h = PlayerDeadSrcRect.h;
  Player.Bonus = StartBonus; // default value...

  STAGE_NUMBER = Stage;
  intLives--;
  int PlayerMoveCounter;
  PlayerMoveCounter = 0;
  timecounter = SDL_GetTicks(); // reset counter
  while(PlayerMoveCounter < 30)
  {
    if(SDL_GetTicks() - timecounter > 10)
    {
      timecounter = SDL_GetTicks(); // reset counter
      drawBackground(StageBackgroundColour, 0, 0);
      Animation();
      drawTiles();
      PlayerDeadRect.y =PlayerDeadRect.y-(3*ScaleValue);
      PlayerMoveCounter++;
      //if(intLives >= 0){Print (96,16,0,  "oi! you died !!!");}
      if(intLives < 0) {Print (96,16,0,  "    GAME OVER   ");}
      SDL_BlitSurface(PlayerSpritesSurface,&PlayerDeadSrcRect,DisplaySurface,&PlayerDeadRect);
      SDL_UpdateRect(DisplaySurface,0,0,0,0);
    }
  }

  while(PlayerDeadRect.y < 350*ScaleValue)
  {
    if(SDL_GetTicks() - timecounter > 10)
    {
      timecounter = SDL_GetTicks(); // reset counter
      drawBackground(StageBackgroundColour, 0, 0);
      Animation();
      drawTiles();
      PlayerDeadRect.y =PlayerDeadRect.y+(3*ScaleValue);
      //if(intLives >= 0){Print (96,16,0,  "oi! you died !!!");}
      if(intLives < 0) {Print (96,16,0,  "    GAME OVER   ");}
      SDL_BlitSurface(PlayerSpritesSurface,&PlayerDeadSrcRect,DisplaySurface,&PlayerDeadRect);
      SDL_UpdateRect(DisplaySurface,0,0,0,0);
    }
  }
  loadStage();
  getInput();
}

