#include "_variables.h"

int CurrentTileTopX[5];
int CurrentTileTopY[5];
int CurrentTileBottomX[5];
int CurrentTileBottomY[5];
int CurrentTileRightX[8];
int CurrentTileRightY[8];
int CurrentTileLeftX[8];
int CurrentTileLeftY[8];

int CurrentTileNextRightX;
int CurrentTileNextRightY;
int CurrentTileNextRightX1; // needed for angled tile detection
int CurrentTileNextRightY1; // needed for angled tile detection
int CurrentTileNextRightBottomX;
int CurrentTileNextRightBottomY;
int CurrentTileNextBottomX;
int CurrentTileNextBottomY;


int CurrentTileNextLeftX;
int CurrentTileNextLeftY;
int CurrentTileNextLeftX1; // needed for angled tile detection
int CurrentTileNextLeftY1; // needed for angled tile detection
int CurrentTileNextLeftBottomX;
int CurrentTileNextLeftBottomY;

int MovementSpeed = 1;


int RepeatCounter;





void getCurrentTile()
{
  /* width = 15  */
  /* height = 21 */
 
  int PlayerHeight = 21;
  if(SystemNumber==2 && Player.Bonus == 0){PlayerHeight = 22;}
  if(SystemNumber==2 && Player.Bonus > 0){PlayerHeight = 23;}
  int KopfValue = 4;

  // tiles on top
  CurrentTileTopX[1] = ((Player.x + 0) / 8); 
  CurrentTileTopY[1] = ((Player.y + KopfValue) / 8); //0
  CurrentTileTopX[2] = ((Player.x + 5) / 8); 
  CurrentTileTopY[2] = ((Player.y + KopfValue) / 8); //5
  CurrentTileTopX[3] = ((Player.x + 10) / 8); 
  CurrentTileTopY[3] = ((Player.y + KopfValue) / 8); //10
  CurrentTileTopX[4] = ((Player.x + 14) / 8); 
  CurrentTileTopY[4] = ((Player.y + KopfValue) / 8); //15

  // tiles on the bottom
  CurrentTileBottomX[1] = ((Player.x + 0) / 8); 
  CurrentTileBottomY[1] = ((Player.y + PlayerHeight) / 8); //0
  CurrentTileBottomX[2] = ((Player.x + 5) / 8); 
  CurrentTileBottomY[2] = ((Player.y + PlayerHeight) / 8); //5
  CurrentTileBottomX[3] = ((Player.x + 10) / 8); 
  CurrentTileBottomY[3] = ((Player.y + PlayerHeight) / 8); //10
  CurrentTileBottomX[4] = ((Player.x + 14) / 8); 
  CurrentTileBottomY[4] = ((Player.y + PlayerHeight) / 8); //15

  // tiles to the left
  CurrentTileLeftX[1] = ((Player.x - 1) / 8);
  CurrentTileLeftY[1] = ((Player.y + KopfValue) / 8); //0
  CurrentTileLeftX[2] = ((Player.x - 1) / 8);
  CurrentTileLeftY[2] = ((Player.y + 7) / 8); //5
  CurrentTileLeftX[3] = ((Player.x - 1) / 8);
  CurrentTileLeftY[3] = ((Player.y + 10) / 8); //10
  CurrentTileLeftX[4] = ((Player.x - 1) / 8);
  CurrentTileLeftY[4] = ((Player.y + 15) / 8); //15
  CurrentTileLeftX[5] = ((Player.x - 1) / 8);
  CurrentTileLeftY[5] = ((Player.y + 20) / 8); //21
  //tiles needed for clinging to the edge...
  CurrentTileLeftX[6] = ((Player.x -1) / 8);
  CurrentTileLeftY[6] = ((Player.y + 7) / 8); //15
  CurrentTileLeftX[7] = ((Player.x -1) / 8);
  CurrentTileLeftY[7] = ((Player.y + 9) / 8); //21

  //tiles to the right
  CurrentTileRightX[1] = ((Player.x + 15) / 8);
  CurrentTileRightY[1] = ((Player.y + KopfValue) / 8);  //0
  CurrentTileRightX[2] = ((Player.x + 15) / 8);
  CurrentTileRightY[2] = ((Player.y + 7) / 8);  //5
  CurrentTileRightX[3] = ((Player.x + 15) / 8);
  CurrentTileRightY[3] = ((Player.y + 10) / 8); //10
  CurrentTileRightX[4] = ((Player.x + 15) / 8);
  CurrentTileRightY[4] = ((Player.y + 15) / 8); //15
  CurrentTileRightX[5] = ((Player.x + 15) / 8);
  CurrentTileRightY[5] = ((Player.y + 20) / 8); //21
  //tiles needed for clinging to the edge...
  CurrentTileRightX[6] = ((Player.x + 15) / 8);
  CurrentTileRightY[6] = ((Player.y + 7) / 8); //15
  CurrentTileRightX[7] = ((Player.x + 15) / 8);
  CurrentTileRightY[7] = ((Player.y + 9) / 8); //21

  CurrentTileNextRightX = ((Player.x + 16) / 8);
  CurrentTileNextRightY = ((Player.y + PlayerHeight) / 8);
  CurrentTileNextRightX1 = ((Player.x + 14) / 8);  // needed for angled ground
  CurrentTileNextRightY1 = ((Player.y + 20) / 8);  // needed for angled ground
  CurrentTileNextRightBottomX = ((Player.x + 16) / 8);
  CurrentTileNextRightBottomY = ((Player.y + PlayerHeight + 1) / 8);
  CurrentTileNextBottomX = ((Player.x + 14) / 8);
  CurrentTileNextBottomY = ((Player.y + PlayerHeight + 1) / 8);

  CurrentTileNextLeftX = ((Player.x-1) / 8);
  CurrentTileNextLeftY = ((Player.y + PlayerHeight) / 8);
  CurrentTileNextLeftX1 = ((Player.x) / 8);  // needed for angled ground
  CurrentTileNextLeftY1 = ((Player.y + 20) / 8);  // needed for angled ground
  CurrentTileNextLeftBottomX = ((Player.x-1) / 8);
  CurrentTileNextLeftBottomY = ((Player.y + PlayerHeight + 1) / 8);

  // needed to prevent bugs!
  if(CurrentTileRightX[1]>255){CurrentTileRightX[1]=255;}
  if(CurrentTileRightX[2]>255){CurrentTileRightX[2]=255;}
  if(CurrentTileRightX[3]>255){CurrentTileRightX[3]=255;}
  if(CurrentTileRightX[4]>255){CurrentTileRightX[4]=255;}
  if(CurrentTileBottomX[1]>255){CurrentTileBottomX[1]=255;}
  if(CurrentTileBottomX[2]>255){CurrentTileBottomX[2]=255;}
  if(CurrentTileBottomX[3]>255){CurrentTileBottomX[3]=255;}
  if(CurrentTileBottomX[4]>255){CurrentTileBottomX[4]=255;}
}
