#include "_variables.h"

Uint32 timecounter;
Uint32 AnimationCounter = 0;
int StartStage;
char StageNumberChar[] = "  ";
void drawTextWindow();

void Titlescreen()
{
  drawBackground(1,0, 0);
  loadRecords();
  STAGE_NUMBER = 0;
  loadStage();
  getInput();
  int TitlescreenDirection = 1;
  Player.onground = true;
  getInput();

  while(!Key_ESCAPE_pressed)
  {
    if(SDL_GetTicks() - timecounter > 10)
    {
      timecounter = SDL_GetTicks(); // reset counter
      drawBackground(StageBackgroundColour, 0, 0);
      Animation();
      drawTiles();

      drawTextWindow();

      Print (16,188,0, "Start = START");
      Print (16,198,0, "Stats = L");
      Print (16,218,0, "QUIT  = SELECT");
      if(StartStage<10){Print (16,208,0, "Level = <0 >");}
      if(StartStage>9){Print (16,208,0, "Level = <  >");}
    //  itoa(StartStage,StageNumberChar,10);
    //  Print (80,208, StageNumberChar);
      
      if(StartStage<10){PrintInt (96,208,0, StartStage);}
      if(StartStage>9){PrintInt (88,208,0, StartStage);}

      drawMouseCursor();

      SDL_UpdateRect(DisplaySurface,0,0,0,0);
      if(Player.x < 0) {TitlescreenDirection = 1;}
      if(Player.x > STAGEWIDTH * TILESIZE)	{TitlescreenDirection = 0;}
      if(TitlescreenDirection == 1){Player.x++;}
      if(TitlescreenDirection == 0){Player.x--;}
    }

  if(MouseX>7*ScaleValue && MouseX < 145*ScaleValue && MouseY <233*ScaleValue && MouseY > 183*ScaleValue)
  {
    if(MOUSE_RIGHT_pressed){StartStage--; playSound(3);if(StartStage<0){StartStage=LASTSTAGE;}}
    if(MOUSE_LEFT_pressed){StartStage++; playSound(3);if(StartStage>LASTSTAGE){StartStage=0;}}    
  }
      
    if(Key_F11_pressed)  {getInput();DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_ANYFORMAT);}
    if(Key_F12_pressed)  {getInput();DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_SWSURFACE|SDL_FULLSCREEN);}
    if(Key_LEFT_pressed) {StartStage--; playSound(3);if(StartStage<0){StartStage=LASTSTAGE;}}
    if(Key_RIGHT_pressed){StartStage++; playSound(3);if(StartStage>LASTSTAGE){StartStage=0;}}
    if(Key_DOWN_pressed) {Mix_VolumeMusic(Mix_VolumeMusic(-1)-10);}
    if(Key_UP_pressed)   {Mix_VolumeMusic(Mix_VolumeMusic(-1)+10);}
    if(Key_1_pressed)    {gotoinfoscreen();}
    if(Key_ENTER_pressed)
    {
      Mix_HaltMusic();
      startGame(StartStage);
      if(PlayMusic){Mix_PlayMusic(BackgroundMusic,-1);}
    }
    getInput();
  }
  //else this is the end...
  Mix_FreeMusic(BackgroundMusic);	//free the music
}

void startGame(Uint32 Stage)
{
  intLives = 11;
  intPoints = 0;
  intCoins = 0;
  StageMission = 0;

  ReStartPosition = 0;
  Player.Bonus = StartBonus; // default value...
//  loadRecords();

  STAGE_NUMBER = Stage;
  timecounter = SDL_GetTicks(); // reset counter
  /*
  while(SDL_GetTicks() - timecounter < 1000)
  {
    drawBackground(1,0,0);
    Print (96,112,  "starting game...");	
    SDL_UpdateRect(DisplaySurface,0,0,0,0);
  }
  */
  getInput();
  gameLoop();
}

void drawMouseCursor()
{
  SDL_Rect TempCursorRect;
  int MouseX, MouseY;
  SDL_PumpEvents();
  SDL_GetMouseState(&MouseX, &MouseY);
  TempCursorRect.x = MouseX;
  TempCursorRect.y = MouseY;
  TempCursorRect.w = MouseCursorRect.w;
  TempCursorRect.h = MouseCursorRect.h;
  SDL_BlitSurface(TilesSurface,&MouseCursorRect,DisplaySurface,&TempCursorRect);
}

void drawTextWindow()
{
  SDL_Rect TempWindowSrcRect;
  SDL_Rect TempWindowDstRect;
  TempWindowSrcRect.w = 144*ScaleValue;
  TempWindowSrcRect.h = 8*ScaleValue;
  TempWindowDstRect.w = 144*ScaleValue;
  TempWindowDstRect.h = 8*ScaleValue;
  TempWindowSrcRect.x = 0*ScaleValue;
  TempWindowDstRect.x = 8*ScaleValue;

  SDL_SetAlpha(FontSurface, SDL_SRCALPHA , 200);

  if(MouseX>7*ScaleValue && MouseX < 145*ScaleValue && MouseY <233*ScaleValue && MouseY > 183*ScaleValue)
  {
    SDL_SetAlpha(FontSurface, SDL_SRCALPHA , 255);
    Print(14, 168,0,"click to change startlevel!");
  }

  TempWindowSrcRect.y = 72*ScaleValue;
  TempWindowDstRect.y = 182*ScaleValue;
  SDL_BlitSurface(FontSurface,&TempWindowSrcRect,DisplaySurface,&TempWindowDstRect);

  TempWindowSrcRect.y = 80*ScaleValue;
  TempWindowDstRect.y += 8*ScaleValue;
  SDL_BlitSurface(FontSurface,&TempWindowSrcRect,DisplaySurface,&TempWindowDstRect);

  TempWindowDstRect.y += 8*ScaleValue;
  SDL_BlitSurface(FontSurface,&TempWindowSrcRect,DisplaySurface,&TempWindowDstRect);

  TempWindowDstRect.y += 8*ScaleValue;
  SDL_BlitSurface(FontSurface,&TempWindowSrcRect,DisplaySurface,&TempWindowDstRect);

  TempWindowDstRect.y += 8*ScaleValue;
  SDL_BlitSurface(FontSurface,&TempWindowSrcRect,DisplaySurface,&TempWindowDstRect);


  TempWindowSrcRect.y = 88*ScaleValue;
  TempWindowDstRect.y += 8*ScaleValue;
  SDL_BlitSurface(FontSurface,&TempWindowSrcRect,DisplaySurface,&TempWindowDstRect);

  SDL_SetAlpha(FontSurface, SDL_SRCALPHA , 255);
}
