#include "_variables.h"

Uint32 EnemyAnimationCounter = 0;
Uint32 EnemyAnimationNumber = 0;
Uint32 BulletAnimationNumber = 0;
Uint16 GeneralAnimationCounter_3 = 0;
Uint16 GeneralAnimationCounter_4 = 0;
Uint16 GeneralAnimationCounter_5 = 0;
Uint16 GeneralAnimationCounter_6 = 0;

void Animation()
{
  bool JumpOut=false;
  bool JumpOut2=false;
  AnimationCounter++;
  if(AnimationCounter == 10)
  {
    AnimationCounter = 0;
    for(int v = 0; v < STAGEHEIGHT; v++)
    {
      for(int w = 0; w < STAGEWIDTH; w++)
      {
        if(TileAnimation[TileArray[w][v]].animated == 1)
        {
          TileArray[w][v] = TileAnimation[TileArray[w][v]].nexttile;
        }
      }
    }
  // C64 animations
  if(SystemNumber==2)
  {
    //big chrystals
    if(GeneralAnimationCounter_5==4)
    {
      TileSrcRect[3].x = 64*ScaleValue; TileSrcRect[3].y = 320*ScaleValue;
      TileSrcRect[4].x = 72*ScaleValue; TileSrcRect[4].y = 320*ScaleValue;
      TileSrcRect[43].x = 64*ScaleValue; TileSrcRect[43].y = 328*ScaleValue;
      TileSrcRect[44].x = 72*ScaleValue; TileSrcRect[44].y = 328*ScaleValue;
    }

    if(GeneralAnimationCounter_5==3)
    {
      TileSrcRect[3].x = 48*ScaleValue; TileSrcRect[3].y = 320*ScaleValue;
      TileSrcRect[4].x = 56*ScaleValue; TileSrcRect[4].y = 320*ScaleValue;
      TileSrcRect[43].x = 48*ScaleValue; TileSrcRect[43].y = 328*ScaleValue;
      TileSrcRect[44].x = 56*ScaleValue; TileSrcRect[44].y = 328*ScaleValue;
    }

    if(GeneralAnimationCounter_5==2)
    {
      TileSrcRect[3].x = 32*ScaleValue; TileSrcRect[3].y = 320*ScaleValue;
      TileSrcRect[4].x = 40*ScaleValue; TileSrcRect[4].y = 320*ScaleValue;
      TileSrcRect[43].x = 32*ScaleValue; TileSrcRect[43].y = 328*ScaleValue;
      TileSrcRect[44].x = 40*ScaleValue; TileSrcRect[44].y = 328*ScaleValue;
    }

    if(GeneralAnimationCounter_5==1)
    {
      TileSrcRect[3].x = 16*ScaleValue; TileSrcRect[3].y = 320*ScaleValue;
      TileSrcRect[4].x = 24*ScaleValue; TileSrcRect[4].y = 320*ScaleValue;
      TileSrcRect[43].x = 16*ScaleValue; TileSrcRect[43].y = 328*ScaleValue;
      TileSrcRect[44].x = 24*ScaleValue; TileSrcRect[44].y = 328*ScaleValue;
    }

    if(GeneralAnimationCounter_5==0)
    {
      TileSrcRect[3].x = 0*ScaleValue; TileSrcRect[3].y = 320*ScaleValue;
      TileSrcRect[4].x = 8*ScaleValue; TileSrcRect[4].y = 320*ScaleValue;
      TileSrcRect[43].x = 0*ScaleValue; TileSrcRect[43].y = 328*ScaleValue;
      TileSrcRect[44].x = 8*ScaleValue; TileSrcRect[44].y = 328*ScaleValue;
    }
    //big chrystals

    //tiny chrystals
    if(GeneralAnimationCounter_6==5){TileSrcRect[45].x = 40*ScaleValue; TileSrcRect[45].y=24*ScaleValue;}
    if(GeneralAnimationCounter_6==4){TileSrcRect[45].x = 32*ScaleValue; TileSrcRect[45].y=24*ScaleValue;}
    if(GeneralAnimationCounter_6==3){TileSrcRect[45].x = 24*ScaleValue; TileSrcRect[45].y=24*ScaleValue;}
    if(GeneralAnimationCounter_6==2){TileSrcRect[45].x = 40*ScaleValue; TileSrcRect[45].y=16*ScaleValue;}
    if(GeneralAnimationCounter_6==1){TileSrcRect[45].x = 32*ScaleValue; TileSrcRect[45].y=16*ScaleValue;}
    if(GeneralAnimationCounter_6==0){TileSrcRect[45].x = 24*ScaleValue; TileSrcRect[45].y=16*ScaleValue;}
    //tiny chrystals

    //water
    if(GeneralAnimationCounter_4==3){TileSrcRect[253].x = 0*ScaleValue; TileSrcRect[253].y=336*ScaleValue;}
    if(GeneralAnimationCounter_4==2){TileSrcRect[253].x = 0*ScaleValue; TileSrcRect[253].y=344*ScaleValue;}
    if(GeneralAnimationCounter_4==1){TileSrcRect[253].x = 0*ScaleValue; TileSrcRect[253].y=352*ScaleValue;}
    if(GeneralAnimationCounter_4==0){TileSrcRect[253].x = 0*ScaleValue; TileSrcRect[253].y=360*ScaleValue;}

    if(GeneralAnimationCounter_4==3){TileSrcRect[254].x = 8*ScaleValue; TileSrcRect[254].y=336*ScaleValue;}
    if(GeneralAnimationCounter_4==2){TileSrcRect[254].x = 8*ScaleValue; TileSrcRect[254].y=344*ScaleValue;}
    if(GeneralAnimationCounter_4==1){TileSrcRect[254].x = 8*ScaleValue; TileSrcRect[254].y=352*ScaleValue;}
    if(GeneralAnimationCounter_4==0){TileSrcRect[254].x = 8*ScaleValue; TileSrcRect[254].y=360*ScaleValue;}

    if(GeneralAnimationCounter_4==3){TileSrcRect[255].x = 16*ScaleValue; TileSrcRect[255].y=336*ScaleValue;}
    if(GeneralAnimationCounter_4==2){TileSrcRect[255].x = 16*ScaleValue; TileSrcRect[255].y=344*ScaleValue;}
    if(GeneralAnimationCounter_4==1){TileSrcRect[255].x = 16*ScaleValue; TileSrcRect[255].y=352*ScaleValue;}
    if(GeneralAnimationCounter_4==0){TileSrcRect[255].x = 16*ScaleValue; TileSrcRect[255].y=360*ScaleValue;}
    //water


    //bonuses
    if(GeneralAnimationCounter_5==0){BonusSrcRect[1].x = 0*ScaleValue;}
    if(GeneralAnimationCounter_5==1){BonusSrcRect[1].x = 24*ScaleValue;}
    if(GeneralAnimationCounter_5==2){BonusSrcRect[1].x = 48*ScaleValue;}
    if(GeneralAnimationCounter_5==3){BonusSrcRect[1].x = 72*ScaleValue;}
    if(GeneralAnimationCounter_5==4){BonusSrcRect[1].x = 96*ScaleValue;}

    if(GeneralAnimationCounter_3==0)
    {
      BonusSrcRect[2].x = 0*ScaleValue;
      BonusSrcRect[3].x = 48*ScaleValue;
      BonusSrcRect[5].x = 0*ScaleValue;
      BonusSrcRect[6].x = 72*ScaleValue;
      BonusSrcRect[7].x = 0*ScaleValue;
    }

    if(GeneralAnimationCounter_3==1)
    {
      BonusSrcRect[2].x = 16*ScaleValue;
      BonusSrcRect[3].x = 72*ScaleValue;
      BonusSrcRect[5].x = 24*ScaleValue;
      BonusSrcRect[6].x = 88*ScaleValue;
      BonusSrcRect[7].x = 16*ScaleValue;
    }

    if(GeneralAnimationCounter_3==2)
    {
      BonusSrcRect[2].x = 32*ScaleValue;
      BonusSrcRect[3].x = 96*ScaleValue;
      BonusSrcRect[5].x = 48*ScaleValue;
      BonusSrcRect[6].x = 104*ScaleValue;
      BonusSrcRect[7].x = 32*ScaleValue;
    }
    //bonuses

    GeneralAnimationCounter_3++;
    GeneralAnimationCounter_4++;
    GeneralAnimationCounter_5++;
    GeneralAnimationCounter_6++;
    if(GeneralAnimationCounter_6>5){GeneralAnimationCounter_6=0;}
    if(GeneralAnimationCounter_5>4){GeneralAnimationCounter_5=0;}
    if(GeneralAnimationCounter_4>3){GeneralAnimationCounter_4=0;}
    if(GeneralAnimationCounter_3>2){GeneralAnimationCounter_3=0;}
    }
    // C64 animations

  }
	
  WalkAnimationCounter++;
  if(WalkAnimationCounter > 10)
  {
    WalkAnimationCounter = 0;
    WalkAnimationNumber++;
    if(WalkAnimationNumber == 3){WalkAnimationNumber = 1;}
  }

  EnemyAnimationCounter++;
  if(EnemyAnimationCounter > 10)
  {
    EnemyAnimationCounter = 0;
    EnemyAnimationNumber++;
    BulletAnimationNumber++;
    if(EnemyAnimationNumber > 4){EnemyAnimationNumber = 1;}
    if(BulletAnimationNumber > 3){BulletAnimationNumber = 0;}
  }
}
