#include "_variables.h"

SDL_Rect PlayerTempRect;
SDL_Rect TestRect;

void drawPlayer()
{
  PlayerTempRect.x = (STAGE_XPos + Player.x)*ScaleValue;
  PlayerTempRect.y = (Player.y)*ScaleValue;
  PlayerTempRect.w = PlayerRightSrcRect[0].w;
  PlayerTempRect.h = PlayerRightSrcRect[0].h;

  TestRect.x = 0;
  TestRect.y = 0;
  TestRect.w = 10;
  TestRect.h = 10;

  if(PlayerTempRect.x < 0) {PlayerTempRect.x = 0;}
  if(PlayerTempRect.x > SCREENWIDTH*ScaleValue-PlayerTempRect.w){PlayerTempRect.x = SCREENWIDTH*ScaleValue-PlayerTempRect.w;}

  if(!StompAttack && Key_RIGHT){Player.direction = 1;}
  if(!StompAttack && Key_LEFT) {Player.direction = 0;}

  //**********************
  // draw/move sprite
  if(TurningPunk==0)
  {
  // player is in the air
  if(!Player.onground && !onAngledGround)
  {
    PlayerTempRect.x = PlayerTempRect.x - 3;	
    if(Player.direction == 1)
    {
      if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerJumpRightSrcRect,DisplaySurface,&PlayerTempRect);}
      if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkJumpRightSrcRect,DisplaySurface,&PlayerTempRect);}
    }
    if(Player.direction == 0)
    {
      if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerJumpLeftSrcRect,DisplaySurface,&PlayerTempRect);}
      if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkJumpLeftSrcRect,DisplaySurface,&PlayerTempRect);}
    }
  }

  // player is on the ground!
  else
  {
    if(Key_RIGHT)
    {
      if(Player.accelleration >= 0)
      {
        if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerRightSrcRect[WalkAnimationNumber],DisplaySurface,&PlayerTempRect);}
        if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkRightSrcRect[WalkAnimationNumber],DisplaySurface,&PlayerTempRect);}
      }
      if(Player.accelleration < 0)
      {
        if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerTurnRightSrcRect,DisplaySurface,&PlayerTempRect);}
        if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkTurnRightSrcRect,DisplaySurface,&PlayerTempRect);}
      }
    }

    if(Key_LEFT)
    {
      if(Player.accelleration <= -0)
      {
        if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerLeftSrcRect[WalkAnimationNumber],DisplaySurface,&PlayerTempRect);}
        if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkLeftSrcRect[WalkAnimationNumber],DisplaySurface,&PlayerTempRect);}
      }
      if(Player.accelleration > -0)
      {
        if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerTurnLeftSrcRect,DisplaySurface,&PlayerTempRect);}
        if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkTurnLeftSrcRect,DisplaySurface,&PlayerTempRect);}
      }
    }

    if(!Key_RIGHT && !Key_LEFT)
    {
      if(Player.direction == 1)
      {
        if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerRightSrcRect[0],DisplaySurface,&PlayerTempRect);}
        if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkRightSrcRect[0],DisplaySurface,&PlayerTempRect);}
      }
      if(Player.direction == 0)
      {
        if(Player.Bonus == 0){SDL_BlitSurface(PlayerSpritesSurface,&PlayerLeftSrcRect[0],DisplaySurface,&PlayerTempRect);}
        if(Player.Bonus > 0) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerPunkLeftSrcRect[0],DisplaySurface,&PlayerTempRect);}
      }
    }
  }
  }

  if(TurningPunk>0)
  {
if(TurningPunk>44){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[0],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>39 && TurningPunk<45){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[1],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>34 && TurningPunk<40){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[0],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>29 && TurningPunk<35){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[1],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>24 && TurningPunk<30){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[0],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>19 && TurningPunk<25){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[1],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>14 && TurningPunk<20){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[0],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>9 && TurningPunk<15) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[1],DisplaySurface,&PlayerTempRect);}
if(TurningPunk>4 && TurningPunk<10) {SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[0],DisplaySurface,&PlayerTempRect);}
if(TurningPunk<5){SDL_BlitSurface(PlayerSpritesSurface,&PlayerMorphSrcRect[1],DisplaySurface,&PlayerTempRect);}
  }

onAngledGround = false;  // reset the value. This is needed so the programm doesn't draw the jumping sprite
//**********************
}
