#include "_variables.h"


void Intro()
{
  SDL_Rect IntroSrcRect;
  SDL_Rect IntroDstRect;
  Uint32 introTimer;
  Uint32 introBlendingTimer;
  int alphaValue = 0;
  IntroSrcRect.x = 0;
  IntroSrcRect.y = 0;
  IntroSrcRect.w = 320*ScaleValue;
  IntroSrcRect.h = 240*ScaleValue;
  IntroDstRect.x = 0;
  IntroDstRect.y = 20*ScaleValue;
  IntroDstRect.w = 320*ScaleValue;
  IntroDstRect.h = 240*ScaleValue;

  drawBackground(1,0,0);
  SDL_UpdateRect(DisplaySurface,0,0,0,0);

  // leave the screen black for a moment...
  introTimer = SDL_GetTicks();
//  while (SDL_GetTicks() - introTimer < 1500){}

  Mix_PlayChannel(0,WavChunk[0],-1);   //play the chunk

  // fading in the image
  introTimer = SDL_GetTicks();
  introBlendingTimer = SDL_GetTicks();
  while (SDL_GetTicks() - introTimer < 5000 && !Key_ESCAPE_pressed && !Key_ENTER_pressed && !Button_2_pressed)
  {
    getInput(); 
    if(SDL_GetTicks() - introBlendingTimer > 8)
    {
      introBlendingTimer = SDL_GetTicks();
      if(alphaValue<256){alphaValue++;}
      SDL_SetAlpha(IntroSurface, SDL_SRCALPHA , alphaValue);
      SDL_BlitSurface(IntroSurface,&IntroSrcRect,DisplaySurface,&IntroDstRect);
/*
      if(SystemNumber==0){Print(1,224,0,"Loading default version...");}
      if(SystemNumber==1){Print(1,224,0,"Loading amiga version...");}
      if(SystemNumber==2){Print(1,224,0,"Loading c64 version...");}
      if(SystemNumber==3){Print(1,224,0,"Loading atari version...");}
      if(SystemNumber==4){Print(1,224,0,"Loading amstradcpc version...");}
*/
      SDL_UpdateRect(DisplaySurface,0,0,0,0);
    }
  }
  Mix_HaltChannel(-1); // halt sounds on all channels
  Titlescreen();
}
