
extern int TileArray[STAGEWIDTH][STAGEHEIGHT];
extern int STAGE_NUMBER;
extern int STAGE_XPos;
extern int STAGE_YPos;
extern int TopLeft_Tile_X;
extern int TopRight_Tile_X;
extern int ReStartPosition;
extern int StartTime;

void loadStage();

typedef struct _Level_Struct {
  char Name[100];          // name of the level (default = "noname")
  int Number;              // every level has a number
  int Array[256][30];      // tile array
  int TileType;            // above ground, underground, different colours...
  int BackgroundColour;    // background colour (blue or black)
  int StartPositionX[4];
  int StartPositionY[4];
  int WarpToLevel;
  int PlatformInUse;
  int PlatformX;
  int PlatformY;
  int PlatformType;
  int PlatformDirection;
  int PlatformPathLength;
  int PlatformMovePos;
  int Enemy_Type[15];
  int Enemy_InUse[15];
  int Enemy_Direction[15];
  int Enemy_PosX[15];
  int Enemy_PosY[15];
  int Sublevel_Array[40][30];
  int Sublevel_StartPositionX;
  int Sublevel_StartPositionY;
  int Sublevel_PlatformInUse;
  int Sublevel_PlatformX;
  int Sublevel_PlatformY;
  int Sublevel_PlatformType;
  int Sublevel_PlatformDirection;
  int Sublevel_PlatformPathlength;
  int Sublevel_PlatformMovePos;
} Level_Struct;
extern Level_Struct Level;
