#include "_variables.h"
int GravitySpeed = 3;
bool onAngledGround;
void checkStandingOnAngledTile();

void addGravity()
{
  PlayerClingsRight = false;
  PlayerClingsLeft = false;
  GravitySpeed = 3;
  if(StompAttack){GravitySpeed = 6;}

  for(RepeatCounter = 0; RepeatCounter < GravitySpeed; RepeatCounter++)
  {
    getCurrentTile();
    if(PlayerDied==0 && !playerOnPlatform && !onAngledGround)
    {
      //getCurrentTile();
      {
        Player.onground = true;

        checkStandingOnAngledTile();

        if(!TileTypes[TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]].solid &&
           !TileTypes[TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]].solid &&
           !TileTypes[TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]].solid &&
           !TileTypes[TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]].solid && !onAngledGround)
        {
          Player.y++;
          Player.onground = false;
          // is the player standing on a platform???
          checkStandingOnPlatform();



          //let Player stand on the edge of things on the toes
          if(TileTypes[TileArray[CurrentTileNextRightX][CurrentTileNextRightY]].solid == 0 &&
             TileTypes[TileArray[CurrentTileNextBottomX][CurrentTileNextBottomY]].solid == 0 &&
             TileTypes[TileArray[CurrentTileNextRightBottomX][CurrentTileNextRightBottomY]].solid == 1)
          {
            //Player.y--;
            //Player.onground = true;
            Player.x++;
          }
          if(TileTypes[TileArray[CurrentTileNextLeftX][CurrentTileNextLeftY]].solid == 0 &&
             TileTypes[TileArray[CurrentTileNextBottomX][CurrentTileNextBottomY]].solid == 0 &&
             TileTypes[TileArray[CurrentTileNextLeftBottomX][CurrentTileNextLeftBottomY]].solid == 1)
          {
            //Player.y--;
            //Player.onground = true;
            Player.x--;
          }



/*
          //let player cling to the edge of a tile
          if(TileTypes[TileArray[CurrentTileRightX[6]][CurrentTileRightY[6]]].solid == 0 &&
             TileTypes[TileArray[CurrentTileRightX[7]][CurrentTileRightY[7]]].solid == 1)
          {
            Player.y--;
            Player.onground = true;
            PlayerClingsRight = true;
          }
          if(TileTypes[TileArray[CurrentTileLeftX[6]][CurrentTileLeftY[6]]].solid == 0 &&
             TileTypes[TileArray[CurrentTileLeftX[7]][CurrentTileLeftY[7]]].solid == 1)
          {
            Player.y--;
            Player.onground = true;
            PlayerClingsLeft = true;
          }
          //let player cling to the edge of a tile
*/


          // make sure the player doesn't fall out on the bottom
          if(Player.y > 219)
          {
            Player.y = 219;
            Player.onground = true;
          }
          // make sure the player doesn't fall out on the bottom

        }

        // player stands on ground
        else
        {
          if(StompAttack)  // player is stomping on the ground
          {
            stompeffect();
          }
        }
        //onAngledGround = false;  // reset the value
        // player stands on ground

        //check whether Player stands on crumbling ground...
        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==440){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=442;}
        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==441){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=443;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==440){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=442;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==441){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=443;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==440){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=442;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==441){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=443;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==440){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=442;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==441){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=443;}

        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==448){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=450;}
        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==449){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=451;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==448){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=450;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==449){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=451;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==448){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=450;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==449){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=451;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==448){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=450;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==449){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=451;}

        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==456){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=458;}
        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==457){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=459;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==456){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=458;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==457){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=459;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==456){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=458;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==457){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=459;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==456){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=458;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==457){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=459;}

        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==464){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=466;}
        if(TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]==465){TileArray[CurrentTileBottomX[1]][CurrentTileBottomY[1]]=467;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==464){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=466;}
        if(TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]==465){TileArray[CurrentTileBottomX[2]][CurrentTileBottomY[2]]=467;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==464){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=466;}
        if(TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]==465){TileArray[CurrentTileBottomX[3]][CurrentTileBottomY[3]]=467;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==464){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=466;}
        if(TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]==465){TileArray[CurrentTileBottomX[4]][CurrentTileBottomY[4]]=467;}
        //check whether Player stands on crumbling ground... [end]

      }
    }
  }
}



void checkStandingOnAngledTile()
{
  // check whether player stands on angled ground
        // walking up (when walking to the right)
        if(TileArray[CurrentTileNextRightX1][CurrentTileNextRightY1]==35)
        {
          // player = tiley + (playerx-tilex)
          int tiley = 8 * (int((Player.y + 21) / 8));
          //int tilex = 8 * (int(Player.x / 8));
      //    int newy = tiley-22-((8%(Player.x+15))+2);
      //    if(newy < (tiley-22)){newy = tiley-22;}
      //    Player.y = newy;
          int px = int(((Player.x + 15))%8);

          Player.y = tiley-22;

           //if(px==0){Player.y = tiley-15;}
           //if(px==1){Player.y = tiley-16;}
           //if(px==2){Player.y = tiley-17;}
          // if(px==3){Player.y = tiley-17;}
          // if(px==4){Player.y = tiley-18;}
          // if(px==5){Player.y = tiley-19;}
          // if(px==6){Player.y = tiley-20;}
          // if(px==7){Player.y = tiley-21;}

//          Player.y = tiley - 20 - (8-((Player.x+14)-tilex));
          //Player.y = tiley-22;
          //Player.y += (Player.x%8)-4;
          //Player.y -= (Player.x+15)%((Player.x + 15) / 8);
          onAngledGround = true;
          Player.onground = true;
        }

        // walking up (when walking to the left)
        if(TileArray[CurrentTileNextLeftX1][CurrentTileNextLeftY1]==36)
        {
          // player = tiley + (playerx-tilex)
         int ltiley = 8 * (int((Player.y + 21) / 8));
         // int tilex = 8 * (int(Player.x / 8));
//          Player.y = tiley - 20 - (8-((Player.x+14)-tilex));
          Player.y = ltiley-22;
//          Player.y -= (Player.x%8);
          //Player.y -= (Player.x+15)%((Player.x + 15) / 8);
          onAngledGround = true;
          Player.onground = true;
        }
        // check whether player stands on angled ground

}













void checkStandingOnPlatform()
{
  playerOnPlatform = false;

  if(Platform[0].inUse)
  {
    if(PlatformType[Platform[0].type].direction == 1)
    {
      if(Player.x > Platform[0].x - 14 && 
         Player.x < (Platform[0].x + PlatformType[Platform[0].type].w/ScaleValue))
      {
        if((Player.y+21) > (Platform[0].y + Platform[0].movepos - 1) &&
           (Player.y+21) < (Platform[0].y + Platform[0].movepos + 2))
        {
          playerOnPlatform = true;
        }
      }
    }

    if(PlatformType[Platform[0].type].direction == 0)
    {
      if(Player.x > Platform[0].x + Platform[0].movepos - 14 && 
         Player.x < (Platform[0].x + Platform[0].movepos + PlatformType[Platform[0].type].w/ScaleValue))
      {
        if((Player.y+21) > (Platform[0].y - 2) &&
           (Player.y+21) < (Platform[0].y + 3))
        {
          playerOnPlatform = true;
        }
      }
    }
  }
}
